<?php

if ( ! defined( 'ABSPATH' ) ) exit;

// validate our options
function ttv_ezembed_options_player_validate($input) {
$i = 0;
$new_input = array();
$sanitized_colour_theme = '';
$sanitized_publish_status = '';
        if( isset( $input['twitch_settings_game'] ) ) {
            if ($input['twitch_settings_game'] !== '') $i++;
            $new_input['twitch_settings_game'] = sanitize_text_field( $input['twitch_settings_game'] );
        }
        if( isset( $input['twitch_settings_channel'] ) ) {
            if ($input['twitch_settings_channel'] !== '') $i++;
            $new_input['twitch_settings_channel'] = sanitize_text_field( strtolower($input['twitch_settings_channel']) );
            //convert a list of channel IDs to a list of user IDs
            if ($input['twitch_settings_channel'] !== '') {
                $ch = curl_init("https://api.twitch.tv/kraken/users?login=".str_replace(' ', '', $input['twitch_settings_channel']));
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                    'Accept: application/vnd.twitchtv.v5+json',
                    'Client-ID: c9y13nevu8fzazuq2ty6zdqz9f7xlem'
                ));
                $data = curl_exec($ch);
                $response = json_decode($data, true);
                $userList = '';
                foreach ($response['users'] as $channel) {
                    $userList .= $channel['_id'].',';
                }
                $new_input['twitch_settings_channel_id'] = substr($userList, 0, -1);    
            }              
        }
        if( isset( $input['twitch_settings_team'] ) ) {
            if ($input['twitch_settings_team'] !== '') $i++;
            $new_input['twitch_settings_team'] = sanitize_text_field( $input['twitch_settings_team'] );
            //convert a twitch team to a list of user IDs
            if ($input['twitch_settings_team'] !== '') {
                $ch = curl_init("https://api.twitch.tv/kraken/teams/".$input['twitch_settings_team']);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($ch, CURLOPT_HTTPHEADER, array(
                    'Accept: application/vnd.twitchtv.v5+json',
                    'Client-ID: c9y13nevu8fzazuq2ty6zdqz9f7xlem'
                ));
                $data = curl_exec($ch);
                $response = json_decode($data, true);
                $userIds = '';
                $userNames = '';
                foreach ($response['users'] as $channel) {
                    $userIds .= $channel['_id'].',';
                }
                $new_input['twitch_settings_team_id'] = substr($userIds, 0, -1);    
                foreach ($response['users'] as $channel) {
                    $userNames .= $channel['name'].',';
                }
                $new_input['twitch_settings_team_names'] = substr($userNames, 0, -1);  
            }               
        }
        if ($i > 1) {
          add_settings_error('twitch_settings_game', 'channel-game-error', 'You must choose either GAME or CHANNEL or TEAM. Only one will work at a time.', 'error');
        }
        if( isset( $input['twitch_settings_language'] ) )
            $new_input['twitch_settings_language'] = sanitize_text_field( $input['twitch_settings_language'] );

        if( isset( $input['twitch_settings_limit'] ) && $input['twitch_settings_limit'] < 6)  {
                $new_input['twitch_settings_limit'] = sanitize_text_field( $input['twitch_settings_limit'] );
            } else {
                $new_input['twitch_settings_limit'] = 5;
            }

        if( isset( $input['twitch_appearance_colour_theme'] ) ) {
            // Should only be set to either 'dark-theme' or 'light-theme'.
            $sanitized_colour_theme = sanitize_text_field( $input['twitch_appearance_colour_theme'] );
            if ($sanitized_colour_theme !== 'light-theme' && $sanitized_colour_theme !== 'dark-theme') {
                $new_input['twitch_appearance_colour_theme'] = 'dark-theme';
            } else {
                $new_input['twitch_appearance_colour_theme'] = $sanitized_colour_theme;
            }
        }
        
        if( isset( $input['twitch_player_settings_channel_offline'] ) ) {
                $new_input['twitch_player_settings_channel_offline'] = (int) $input['twitch_player_settings_channel_offline'];
            } else {
                $new_input['twitch_player_settings_channel_offline'] = 0;
            }   
            
        if( isset( $input['twitch_player_settings_show_default'] ) ) {
                $new_input['twitch_player_settings_show_default'] = 0;
            }      
            
        if( isset( $input['twitch_player_settings_show_chat'] ) ) {
                $new_input['twitch_player_settings_show_chat'] = 0;
            }                         
            
        return $new_input;
}
?>