( function( $ ) {

var id = twitch_player_vars.id;
var target = '.twitch-player-'+id+' #stream-container ul';
var language = '';
var limit = 5;
var offline = '';
var theme = twitch_player_vars.theme;
if (twitch_player_vars.language !== '') {
language = '&language='+twitch_player_vars.language;
}
if (twitch_player_vars.limit !== '') {
var limit = twitch_player_vars.limit;
}
if (twitch_player_vars.showOffline !== 0) {
var offline = twitch_player_vars.showOffline;
}
if (twitch_player_vars.twitchGames != '') {
    getGameStreams(twitch_player_vars.twitchGames);
} else if (twitch_player_vars.twitchChannelNames != '') {
    var channelNames = twitch_player_vars.twitchChannelNames;
    var channelIds = twitch_player_vars.twitchChannelIds;
    getChannels(channelIds,channelNames);
} else if (twitch_player_vars.twitchTeamNames != '') {
    var teamNames = twitch_player_vars.twitchTeamNames;
    var teamIds = twitch_player_vars.twitchTeamIds;
    getChannels(teamIds,teamNames)
}

//---- ******* END Click Options ******* ----//

//---- ******* Channels ******* ----//

function getChannels(ids,names){
    $.ajax({
        url: 'https://api.twitch.tv/kraken/streams/?channel='+ids,
        type: 'GET',
        headers: {
        'Client-ID': 'c9y13nevu8fzazuq2ty6zdqz9f7xlem',
        'Accept': 'application/vnd.twitchtv.v5+json'
        },
        success: function(data) {
            namesArray = names.split(',');
            onlineArray = data.streams;
            onlineNamesArray = [];
            for (var i=0;i<onlineArray.length;i++) {
                name = onlineArray[i].channel.name;
                onlineNamesArray.push((onlineArray[i].channel.name).toString());
            }
            newArray = (namesArray.filter(n => !onlineNamesArray.includes(n)))
            console.log('[Easy Embed Twitch] - Success - retrieved Channels')    
            appendStreams(data.streams, newArray)
        },
        error: function(data) {
            console.log('[Easy Embed Twitch] - Failed to retrieve Channels')
        }
    });
}

//---- ******* END Channels ******* ----//

//---- ******* Games ******* ----//

function getGameStreams(game) {
    url = 'https://api.twitch.tv/kraken/streams/?game='+game+language;
    $.ajax({
        url: url,
        type: 'GET',
        headers: {
           'Client-ID': 'c9y13nevu8fzazuq2ty6zdqz9f7xlem',
           'Accept': 'application/vnd.twitchtv.v5+json'
        },
        success: function(data) {
            console.log('[Easy Embed Twitch] - Success - Retreieved Game Streams')
            appendStreams(data.streams);
        },
        error: function(data) {
            console.log('[Easy Embed Twitch] - Failed to retreieve Game Streams')
        }
    });
}

//---- ******* End Game ******* ----//

//---- ******* Append Streams ******* ----//

function appendStreams(fullArray,offlineArray='') {
    var limitCounter = 0;
    console.log('[Easy Embed Twitch] - we have '+fullArray.length+' online streams to display')
    console.log('[Easy Embed Twitch] - we have '+offlineArray.length+' offline streams to display')
    console.log('[Easy Embed Twitch] - we have a limit of '+limit)
    if (fullArray.length <= limit) {
        onlineLimit = fullArray.length;
    } else {
        onlineLimit = limit
    }  
    for (var i=0;i<onlineLimit;i++) {
        if ((limitCounter > limit) || (limitCounter > (10/2))) break;
        limitCounter++;    
      var display_name = fullArray[i].channel.display_name;
      var channel_name = fullArray[i].channel.name;
      var preview = fullArray[i].channel.logo;
      var game = fullArray[i].game;
      var login = fullArray[i].channel.name;
      var url = 'https://www.twitch.tv/'+login;
      var viewers = fullArray[i].viewers;
        var html = '<li class="stream"><a target="_blank" href="'+url+'" title="Watch '+display_name+' Now!" data-channel-name='+login+'>';
        html +=  '<div class="twitch-image"><img src="'+preview+'"></div>';
        html += '<div class="twitch-info"><div class="twitch-name">'+display_name+'</div><div class="twitch-title">'+game+'</div><div class="twitch-viewers">'+viewers+'</div>';
        html += '</div></a>';
        html += '</li>';
      $(html).appendTo(target)
      $('#twitch-module.twitch-player').removeClass('loading');
    }   
  
    if ((offlineArray) && (offline == 1)) {
        $.ajax({
            url: 'https://api.twitch.tv/kraken/users?login='+offlineArray.join(),
            type: 'GET',
            headers: {
                'Client-ID': 'c9y13nevu8fzazuq2ty6zdqz9f7xlem',
                'Accept': 'application/vnd.twitchtv.v5+json'
            },
            success: function(data) {
                var offlineStreams = data.users;
                console.log('[Easy Embed Twitch] - Success - Retreieved offline Streams')
                for (var i=0;i<offlineStreams.length;i++) {
                    limitCounter++;
                    if ((limitCounter > limit) || (limitCounter > (10/2))) break;
                    var display_name = offlineStreams[i].display_name;
                    var preview = offlineStreams[i].logo;  
                    var login = offlineStreams[i].name;              
                    var url = 'https://www.twitch.tv/'+login;
                    var html = '<li class="stream"><a target="_blank" href="'+url+'" title="Watch '+display_name+' Now!" data-channel-name='+login+'>';
                    html +=  '<div class="twitch-image"><img src="'+preview+'"></div>';
                    html += '<div class="twitch-info"><div class="twitch-name">'+display_name+'</div><div class="twitch-title">Offline</div>';
                    html += '</div></a>';
                    html += '</li>';
                $(html).appendTo(target)
                $('#twitch-module.twitch-player').removeClass('loading'); 
                }
            }
        })
    }
  
    if ((fullArray.length == 0) && (offline == 0)) {
        $('#twitch-module.twitch-player').removeClass('loading');  
        $("#twitch-module.twitch-player .loader-message").html('<p>No Streams Online.</p>')
    }      
  
}
    
//---- ******* END Append Streams ******* ----//

	var embedStream = function(name,parentId){
      if (theme == 'dark-theme') {
        theme2 = 'dark';
      } else {
        theme2 = 'light';
      }
      layout = 'video';
	  $('#twitch-embed-'+parentId).empty()
      $('#twitch-embed-'+parentId).addClass('active')
	  new Twitch.Embed('twitch-embed-'+parentId, {
	    width: '100%',
	    height: '100%',
	    channel: name,
        theme: theme2,
        layout: layout
	  });
      $("#twitch-module.twitch-player .offline-slide").remove()
	}
	$(document).on('click', '.twitch-player #stream-container ul li a', function(e){
        e.preventDefault()    
        parentId = $(this).parents('#twitch-module').data('id');  	  
	    name = $(this).data('channel-name')
	    embedStream(name,parentId)
	})

} )( jQuery );